

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

extern unsigned long long tim();

int main(int args, char *argv[])
{
    int fd;
    unsigned long long cpu_speed, tt, calib;
    double usec;

    if(args < 2)
    {
        fprintf(stderr, "Usage:\n%s device_file\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    (void)tim();        /* Initialize */
    calib = tim();      /* Calibrate function-call CPU cycles */
    printf("Testing CPU Speed (once at start of program)\n");
    (void)tim();
    (void)sleep(1);
    cpu_speed = tim() - calib;
    printf("CPU speed = %llu Hz\n", cpu_speed);
    printf("Cycles to make the two function calls = %llu\n", calib);
    (void)tim();
    if((fd = open(argv[1], O_RDONLY)) < 0)
    {
        fprintf(stderr, "Hmmm. Can't open %s\n", argv[1]);
        exit(EXIT_FAILURE);
    }
    tt = tim() - calib;
    (void) close(fd);
    usec = (double) tt / (double) cpu_speed;
    usec *= 1e6;
    printf("It took %llu cpu cycles or %f microseconds.\n", tt, usec);
    return 0;
}


